# Semi-Automatic Classification Plugin

![SCP](semiautomaticclassificationplugin.png) The Semi-Automatic Classification Plugin (SCP) is a free open source plugin for QGIS that allows  for the supervised classification of remote sensing images, providing tools for the download, the preprocessing and postprocessing of images.

The overall objective of SCP is to provide a set of intertwined tools for raster processing in order to make an automatic workflow and ease the land cover classification, which could be performed also by people whose main field is not remote sensing.

Search and download is available for ASTER, GOES, Landsat, MODIS, Sentinel-1, Sentinel-2, and Sentinel-3 images. Several algorithms are available for the land cover classification. This plugin requires the installation of GDAL, OGR, Numpy, SciPy, and Matplotlib. Some tools require also the installation of SNAP (ESA Sentinel Application Platform).

## Plugin installation

The SCP is available for QGIS version 3.x.
The SCP is developed with Python 3 and requires the installation of GDAL (OGR), NumPy, SciPy and Matplotlib.

For the installation of QGIS and SCP on different operating systems please follow this [guide](https://semiautomaticclassificationmanual.readthedocs.io/en/latest/installation.html).


## Using the plugin

If you are new to SCP, please follow this [tutorial](https://semiautomaticclassificationmanual.readthedocs.io/en/latest/tutorial_1.html).


## Web site

All the SCP information is available from the [SCP website](https://fromgistors.blogspot.com/p/semi-automatic-classification-plugin.html).

## Documentation

Check [the user manual](https://semiautomaticclassificationmanual.readthedocs.io) or the online [tutorials](https://fromgistors.blogspot.com/search/label/Tutorial) available.

[Videos](https://www.youtube.com/user/fromgistors) are also available.

## Contributing to the development

If you find some issue that you are willing to fix, code contributions are welcome. Please read [the development notes](DEVELOPMENT.md) before contributing. 

## Authors

* **Luca Congedo** 

## License

This plugin is distributed under a GNU General Public License version 3.

## Cite the code
[![DOI](https://zenodo.org/badge/18038317.svg)](https://zenodo.org/badge/latestdoi/18038317)
